//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop
#include "Unit1.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "CPort"
#pragma link "CPortCtl"
#pragma resource "*.dfm"

// (C) Fabrice Sincre ; mai 2011
// IDE : Borland Builder 5
// Composant ComPort

////////////////////////////////////////////
// On utilise la librairie C de MySQL //////
#define __WIN__
#include "mysql.h"
////////////////////////////////////////////

// variables globales

MYSQL *mySQL;
MYSQL_ROW myROW;
MYSQL_RES *myRES;
AnsiString aStr;

int table_existe = 0; // la table n'existe pas encore


double temperature_actuelle = 0.0;

AnsiString temoinreception = " "; // clignotement d'une toile (*) dans la bote "temprature actuelle"


unsigned char tableau[3];
        // TX (RS232)  3 octets transmis vers le PIC
        // 1er octet transmis: tableau[0]
        // 2me octet transmis : tableau[1]
        // 3me octet transmis : tableau[2]

// instruction          1er octet (code instruction)    2me octet (donnes)    3me octet (donnes)

// Read Temperature     0xAA                            0x00 non utilise       0x00 non utilise
// Read TH              0xA1                            0x00 non utilise       0x00 non utilise
// Read TL              0xA2                            0x00 non utilise       0x00 non utilise
// Write TH             0x01                            (0000000 D8)            (D7 ... D0)
// Write TL             0x02                            (0000000 D8)            (D7 ... D0)

int D[9]; // 9 bits (D[8] ... D[0]) : temprature numrique en complment  deux

int flagReadTemperature = 0; // drapeau instruction Read Temperature
int flagReadTH =0;
int flagReadTL =0;
int flagWriteTH =0;
int flagWriteTL =0;

double TH = 15.0;
double TL = 10.0;

TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{

// lecture de la temprature toutes les 1000 ms
Timer1 -> Interval = 1000;
// mise  jour base de donnes toutes les 5 minutes
Timer3 -> Interval = 300000;

}

//---------------------------------------------------------------------------
void requete_mysql(char* requete)
{
// requte SQL

if (!mysql_query(mySQL, requete))
        {
                Form1 ->ListBox1->Items->Add(requete);
                Form1 ->ListBox1->Items->Add("----------");
                Form1 ->ListBox1->Items->Add("");

                myRES = mysql_store_result(mySQL);
                if (myRES)
                {
                        for(unsigned int i = 0; i < myRES->row_count; i++)
                        {
                                myROW = mysql_fetch_row(myRES);
                                for(unsigned int j = 0; j < mysql_num_fields(myRES); j++)
                                {
                                        aStr = myROW[j];
                                        Form1 ->ListBox1->Items->Add(aStr);
                                }
                        }
                        mysql_free_result(myRES);
                }
                Form1 ->ListBox1->Items->Add("");
        }
        else
        {
                // erreur de requte
                const char *message_erreur;
                message_erreur = mysql_error(mySQL);
                Form1 ->ListBox1->Items-> Add(message_erreur);
                Form1 ->ListBox1->Items->Add("----------");
                Form1 ->ListBox1->Items->Add("");

        }

return;
}

//---------------------------------------------------------------------------
void ReadTH(void)
{
// lecture TH

Form1 -> Timer1 ->Enabled =false;
if (flagReadTH ==0 && flagReadTL ==0 && flagWriteTH ==0 && flagWriteTL ==0 && flagReadTemperature ==0)
{
        tableau[0]= 0xA1;
        tableau[1]= 0x00;
        tableau[2]= 0x00;
        flagReadTH = 1;
        flagReadTL = 0;
        flagWriteTH = 0;
        flagWriteTL = 0;
        flagReadTemperature = 0;

        // transmission des 3 octets (liaison RS232)

        // 1er octet transmis: tableau[0]
        // 2me octet transmis : tableau[1]
        // 3me octet transmis : tableau[2]

        Form1->ComPort1->Write(tableau, 3); // Ecrit les 3 octets sur le port srie
}
Form1 -> Timer1 ->Enabled =true;
return;

}

//---------------------------------------------------------------------------
void ReadTL(void)
{
// lecture TL

Form1 -> Timer1 ->Enabled =false;
if (flagReadTH ==0 && flagReadTL ==0 && flagWriteTH ==0 && flagWriteTL ==0 && flagReadTemperature ==0)
{
        tableau[0]= 0xA2;
        tableau[1]= 0x00;
        tableau[2]= 0x00;
        flagReadTL = 1;
        flagReadTH = 0;
        flagWriteTH = 0;
        flagWriteTL = 0;
        flagReadTemperature = 0;
        // transmission des 3 octets (liaison RS232)

        // 1er octet transmis: tableau[0]
        // 2me octet transmis : tableau[1]
        // 3me octet transmis : tableau[2]

        Form1->ComPort1->Write(tableau, 3); // Ecrit les 3 octets sur le port srie
}
Form1 ->Timer1 ->Enabled =true;
return;
}



//---------------------------------------------------------------------------

double bintemp (int *data)
{
// conversion de (D8 ... D0) en complment  2 (tableau D[9])
// en temprature (en C)

// 0 1111 1010 = 250 = +125C (max)
// 0 0000 0001 = 1 = +0,5C
// 0 0000 0000 = 0 = 0C
// 1 1111 1111 = -1 = - 0,5 C
// 1 1001 0010 = -110 = -55C (min)

// D8 = bit de signe
// D8 = 0 : temperature positive
// D8 = 1 : temperature ngative
// 1 1001 0010
// on complmente : 0110 1101 = 109
// +1 = 110 = -55 C

double temperature;

if (data[8] == 0)
{
        temperature = 128*data[7] + 64*data[6] + 32*data[5] + 16*data[4] + 8*data[3] + 4*data[2] + 2*data[1] + data[0];
        temperature = temperature*0.5;
}
else
{
        temperature = 128*(1-data[7]) + 64*(1-data[6]) + 32*(1-data[5]) + 16*(1-data[4]) + 8*(1-data[3]) + 4*(1-data[2]) + 2*(1-data[1]) +(1- data[0]);
        temperature = - (temperature + 1)*0.5;
}

return temperature;
}

//---------------------------------------------------------------------------

void tempbin(double temperature)
{
// conversion de la temperature (en C)
// en un nombre binaire en complment  2
// (dans la variable globale D[9])

temperature = 2*temperature;
int itemperature;
itemperature = temperature;

if (itemperature >=0)
{
        D[8]=0;   // bit de signe

        for (int i=0 ; i < 8 ; i++)
        {
                D[i] = itemperature % 2 ; // reste de la division
                itemperature = itemperature /2 ;
        }
}

else
{
        D[8]=1;      // bit de signe
        itemperature = -itemperature ;
        itemperature = 256 -itemperature;
        for (int i=0 ; i < 8 ; i++)
        {
                D[i] = itemperature % 2 ; // reste de la division
                itemperature = itemperature /2 ;
        }
}

return;
}

//---------------------------------------------------------------------------



void __fastcall TForm1::Timer3Timer(TObject *Sender)
{

// mise  jour base de donnes toutes les 5 minutes

// initialisation
mySQL = mysql_init(NULL);

// conversion AnsiString -> char
char *hostname  = new char[ Edit_host->Text.Length() + 1 ];
strcpy( hostname, Edit_host->Text.c_str() );

char *user  = new char[ Edit_user->Text.Length() + 1 ];
strcpy( user, Edit_user->Text.c_str() );

char *password  = new char[ Edit_password ->Text.Length() + 1 ];
strcpy( password, Edit_password->Text.c_str() );

char *database  = new char[ Edit_database->Text.Length() + 1 ];
strcpy( database, Edit_database->Text.c_str() );


if (!mysql_real_connect(mySQL,hostname,user,password,database,0,NULL,0))
{
        // la connexion a chou
        const char *message_erreur;
        message_erreur = mysql_error(mySQL);
        ListBox1->Items-> Add(message_erreur);
        ListBox1->Items->Add("----------");
        ListBox1->Items->Add("");

}
else
{
        // la connexion a russi

        ListBox1->Items-> Add("Server is connected");
        ListBox1->Items->Add("----------");
        ListBox1->Items->Add("");

        // requte
        AnsiString Requete;
        Requete = "INSERT INTO web_temperature1(ID,date,time,temperature) VALUES (NULL,CURDATE(), CURTIME(),";
        Requete = Requete + "'"+ FloatToStr(temperature_actuelle) +"')";

        // conversion AnsiString -> char
        char *requete  = new char[ Requete.Length() + 1 ];
        strcpy( requete, Requete.c_str() );
        requete_mysql(requete);

        // requte

        requete_mysql("SELECT date,time,temperature FROM web_temperature1 ORDER BY ID DESC LIMIT 0,1");


}
// close

ListBox1->Items-> Add("Close");
ListBox1->Items->Add("----------");
ListBox1->Items->Add("");

mysql_close(mySQL);



}
//---------------------------------------------------------------------------


void __fastcall TForm1::Button7Click(TObject *Sender)
{
ComPort1->Connected=true;  // ouverture du port
Button7->Enabled=false;
Button8->Enabled=true;
Button6->Enabled=false;

GroupBoxThermostat ->Enabled=true;

flagReadTemperature = 0; // drapeau instruction Read Temperature
flagReadTH =0;
flagReadTL =0;
flagWriteTH =0;
flagWriteTL =0;

Timer1 ->Enabled =true;
Timer3 ->Enabled =false;
GroupBox_MySQL ->Enabled =true;
Button_connexion_bdd ->Enabled = true;
Button_fermeture_bdd ->Enabled = false;

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button8Click(TObject *Sender)
{
ComPort1->Connected=false;  // fermeture du port
Button7->Enabled=true;
Button8->Enabled=false;
Button6->Enabled=true;
Timer3->Enabled=false;

GroupBoxThermostat ->Enabled=false;
GroupBox_MySQL ->Enabled =false;

}
//---------------------------------------------------------------------------

void __fastcall TForm1::ComPort1RxChar(TObject *Sender, int Count)
{
// on arrive ici quand on reoit des donnes du port COM

Timer1 ->Enabled =false;

/*
instruction             1er octet (donnes)     2me octet (donnes)

Read Temperature        (0000000 D8)            (D7 ... D0)
Read TH                 (0000000 D8)            (D7 ... D0)
Read TL                 (0000000 D8)            (D7 ... D0)
Write TH                0x00 (non utilis)      0x00 (non utilis)
Write TL                0x00 (non utilis)      0x00 (non utilis)
*/

try
{

unsigned char *datarecu = new unsigned char [Count];
ComPort1->Read(datarecu, Count);
// Lit "Count" octet(s) prsent(s) dans le buffer d'entre et le(s) place dans "datarecu"
// Normalement, on reoit deux octets du PIC

if (flagReadTH == 1)
{
        D[8] = datarecu[0];

        for (int i=0 ; i < 8 ; i++)
        {
                D[i] = datarecu[1] % 2 ; // reste de la division
                datarecu[1] = datarecu[1] /2 ;
        }
        EditTH ->Text =  bintemp (D);
        TH = bintemp (D);

}
else if (flagReadTL == 1)
{
        D[8] = datarecu[0];

        for (int i=0 ; i < 8 ; i++)
        {
                D[i] = datarecu[1] % 2 ; // reste de la division
                datarecu[1] = datarecu[1] /2 ;
        }
        EditTL ->Text =  bintemp (D);
        TL = bintemp (D);
}

else if (flagReadTemperature == 1)
{
        D[8] = datarecu[0];

        for (int i=0 ; i < 8 ; i++)
        {
                D[i] = datarecu[1] % 2 ; // reste de la division
                datarecu[1] = datarecu[1] /2 ;
        }
        temperature_actuelle =  bintemp (D);
       

        // tmoin de rception
        if (temoinreception == " ") temoinreception = "*";
        else temoinreception = " ";
}


else if (flagWriteTH == 1)
{
        if ((datarecu[0] != 0x00) || (datarecu[1] != 0x00))
        {
                Application->MessageBox("Erreur de rception !","Erreur 04",MB_OK);
        }

}

else if (flagWriteTL == 1)
{
        if ((datarecu[0] != 0x00) || (datarecu[1] != 0x00))
        {
                Application->MessageBox("Erreur de rception !","Erreur 05",MB_OK);
        }

}

flagReadTemperature = 0; // drapeau instruction Read Temperature
flagReadTH =0;
flagReadTL =0;
flagWriteTH =0;
flagWriteTL =0;

delete [] datarecu;
datarecu = NULL;
}

catch(...)
{
Application->MessageBox("Erreur de rception !","Erreur 06",MB_OK);
}
Timer1 ->Enabled =true;

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button6Click(TObject *Sender)
{
ComPort1->ShowSetupDialog();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Timer1Timer(TObject *Sender)
{
// on arrive ici toutes les 1000 ms

if (ComPort1->Connected==true)
{
        // lecture de la temprature (instruction Read Temperature)
        tableau[0]= 0xAA;
        tableau[1]= 0x00;
        tableau[2]= 0x00;

        ComPort1->Write(tableau, 3); // Ecrit les 3 octets sur le port srie

        flagReadTemperature = 1;
        flagWriteTH = 0;
        flagReadTL = 0;
        flagReadTH = 0;
        flagWriteTL = 0;

}

// mise  jour affichage de la temprature actuelle + tmoin de rception clignotant
Label6temp -> Caption = FloatToStrF(temperature_actuelle,ffFixed,15,1) + " C " + temoinreception;
// affichage de l'heure courante
Label7time->Caption=TimeToStr(Time());   // AnsiString  hh:mm:ss
Label7date->Caption=DateToStr(Date());   // AnsiString

}
//---------------------------------------------------------------------------



void __fastcall TForm1::ButtonWriteTHClick(TObject *Sender)
{
// criture TH

Timer1 ->Enabled =false;
if (flagReadTH ==0 && flagReadTL ==0 && flagWriteTH ==0 && flagWriteTL ==0 && flagReadTemperature ==0)
{

try
{
double THbak = TH;
TH = EditTH ->  Text.ToDouble();

if ((TH < -55.0) || (TH > 125.0))
{
        Application->MessageBox("La temprature TH doit tre comprise\nentre -55 et +125 C","Erreur 07",MB_OK);
        EditTH ->  Text = THbak;
        TH = THbak;
        ReadTH();
        return;
}
int iTH;
iTH = 2.0*TH;

if ((2.0*TH - iTH) != 0)
{
        Application->MessageBox("La temprature TH doit tre un multiple\nde 0,5 C","Erreur 08",MB_OK);
        EditTH ->  Text = THbak;
        TH = THbak;
        ReadTH();
        return;
}
if (TL >= TH)
{
        Application->MessageBox("La temprature TL doit tre\ninfrieure  la temprature TH","Erreur 09",MB_OK);
        EditTH ->  Text = THbak;
        TH = THbak;
        ReadTH();
        return;
}
// conversion en binaire
tempbin(TH);

tableau[0]= 0x01;
tableau[1]= D[8];
tableau[2] = 128*D[7] + 64*D[6] + 32*D[5] + 16*D[4] + 8*D[3] + 4*D[2] + 2*D[1] + D[0];

flagWriteTH = 1;
flagReadTL = 0;
flagReadTH = 0;
flagWriteTL = 0;
flagReadTemperature = 0;
// transmission des 3 octets (liaison RS232)

// 1er octet transmis: tableau[0]
// 2me octet transmis : tableau[1]
// 3me octet transmis : tableau[2]

ComPort1->Write(tableau, 3); // Ecrit les 3 octets sur le port srie
}
catch(...)
{
Application->MessageBox("Valeur non valide !","Erreur 10",MB_OK);

}
}

Timer1 ->Enabled =true;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ButtonWriteTLClick(TObject *Sender)
{
// criture TL

Timer1 ->Enabled =false;
if (flagReadTH ==0 && flagReadTL ==0 && flagWriteTH ==0 && flagWriteTL ==0 && flagReadTemperature ==0)
{

try
{

double TLbak = TL;
TL = EditTL ->  Text.ToDouble();

if ((TL < -55.0) || (TL > 125.0))
{
        Application->MessageBox("La temprature TL doit tre comprise\nentre -55 et +125 C","Erreur 11",MB_OK);
        EditTL ->  Text = TLbak;
        TL = TLbak;
        ReadTL();
        return;
}
int iTL;
iTL = 2.0*TL;

if ((2.0*TL - iTL) != 0)
{
        Application->MessageBox("La temprature TL doit tre un multiple\nde 0,5 C","Erreur 12",MB_OK);
        EditTL ->  Text = TLbak;
        TL = TLbak;
        ReadTL();
        return;
}
if (TL >= TH)
{
        Application->MessageBox("La temprature TL doit tre\ninfrieure  la temprature TH","Erreur 13",MB_OK);
        EditTL ->  Text = TLbak;
        TL = TLbak;
        ReadTL();
        return;
}

// conversion en binaire
tempbin(TL);

tableau[0]= 0x02;
tableau[1]= D[8];
tableau[2] = 128*D[7] + 64*D[6] + 32*D[5] + 16*D[4] + 8*D[3] + 4*D[2] + 2*D[1] + D[0];

flagWriteTL = 1;
flagReadTH =0;
flagReadTL =0;
flagWriteTH =0;
flagReadTemperature = 0;

// transmission des 3 octets (liaison RS232)

// 1er octet transmis: tableau[0]
// 2me octet transmis : tableau[1]
// 3me octet transmis : tableau[2]

ComPort1->Write(tableau, 3); // Ecrit les 3 octets sur le port srie
}
catch(...)
{
Application->MessageBox("Valeur non valide !","Erreur 14",MB_OK);
}
}
Timer1 ->Enabled =true;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ButtonReadTHClick(TObject *Sender)
{
ReadTH();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ButtonReadTLClick(TObject *Sender)
{
ReadTL();
}
//---------------------------------------------------------------------------


void __fastcall TForm1::Button_connexion_bddClick(TObject *Sender)
{

Button_connexion_bdd ->Enabled = false;
Button_fermeture_bdd ->Enabled = true;

// initialisation
mySQL = mysql_init(NULL);

// conversion AnsiString -> char
char *hostname  = new char[ Edit_host->Text.Length() + 1 ];
strcpy( hostname, Edit_host->Text.c_str() );

char *user  = new char[ Edit_user->Text.Length() + 1 ];
strcpy( user, Edit_user->Text.c_str() );

char *password  = new char[ Edit_password ->Text.Length() + 1 ];
strcpy( password, Edit_password->Text.c_str() );

char *database  = new char[ Edit_database->Text.Length() + 1 ];
strcpy( database, Edit_database->Text.c_str() );


if (!mysql_real_connect(mySQL,hostname,user,password,database,0,NULL,0))
{
        // la connexion a chou
        const char *message_erreur;
        message_erreur = mysql_error(mySQL);
        ListBox1->Items-> Add(message_erreur);
        ListBox1->Items->Add("----------");
        ListBox1->Items->Add("");

}
else
{
        // la connexion a russi

        ListBox1->Items-> Add("Server is connected");
        ListBox1->Items->Add("----------");
        ListBox1->Items->Add("");

        // requte 1
        requete_mysql("CREATE TABLE IF NOT EXISTS web_temperature1 (ID INT(10) NOT NULL AUTO_INCREMENT PRIMARY KEY,date DATE NOT NULL,time TIME NOT NULL,temperature varchar(20) collate latin1_general_ci NOT NULL) ENGINE = MYISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci");
        

        // requte 2
        AnsiString Requete;
        Requete = "INSERT INTO web_temperature1(ID,date,time,temperature) VALUES (NULL,CURDATE(), CURTIME(),";
        Requete = Requete + "'"+ FloatToStr(temperature_actuelle) +"')";

        // conversion AnsiString -> char
        char *requete  = new char[ Requete.Length() + 1 ];
        strcpy( requete, Requete.c_str() );
        requete_mysql(requete);

        // requte 3

        requete_mysql("SELECT date,time,temperature FROM web_temperature1 ORDER BY ID DESC LIMIT 0,1");


}
// close

ListBox1->Items-> Add("Close");
ListBox1->Items->Add("----------");
ListBox1->Items->Add("");

mysql_close(mySQL);

Timer3 ->Enabled =true;

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button_fermeture_bddClick(TObject *Sender)
{
Timer3 ->Enabled =false;
Button_connexion_bdd ->Enabled = true;
Button_fermeture_bdd ->Enabled = false;

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button_clearClick(TObject *Sender)
{
ListBox1->Items->Clear();
}
//---------------------------------------------------------------------------



